/********************************************************************
**                                                                  *
**	Sonst   :	Umstellung auf tr() erfolgt                         *
**                                                                  *
*********************************************************************/



#include "kalenderimpl.h"
#include <qtoolbutton.h>
#include <qlabel.h>
#include <qapplication.h>
#include <qtooltip.h>
#include <qpopupmenu.h>
#include <qcursor.h>
#include <qgroupbox.h>

#ifdef COMPILE_ADVOLUX
#include "qmydate.h"
#endif COMPILE_ADVOLUX

#include "DateValidator.h"
#include "global.h"


static const char* const KalenderBild[] = { 
"18 18 9 1",
". c #000000",
"c c #000080",
"d c #330066",
"f c #6699cc",
"b c #808080",
"a c #a6caf0",
"e c #ccecff",
"# c #ffffff",
"x c none",
".................x",
".aaaaaaaaaaaaaaa.x",
".aaaaaaaaaaaaaaa.b",
".ccccccccccccccccb",
".###############.b",
".#####d##ddd####.b",
".####dd#de#ed###.b",
".###dfd#d###d###.b",
".##cf#d#de#ed###.b",
".#####d##ddd####.b",
".#####d#de#ed###.b",
".#####d#d###d###.b",
".#####d#de#ed###.b",
".#####d##ddd####.b",
".###############.b",
".###############.b",
".................b",
"xxbbbbbbbbbbbbbbbb"};


const QColor background = QColor(230,230,230);
const QColor weekend    = QColor(220,220,230);
const QColor rahmen     = QColor(240,240,250);

// 
//  Constructs a Kalender which is a child of 'parent', with the 
//  name 'name' and widget flags set to 'f' 
//
//  The dialog will by default be modeless, unless you set 'modal' to
//  TRUE to construct a modal dialog.
//


//	Kalender verbindet ein LineEidtFeld und ein ToolButton und simuliert
//	ein Datum controll. Die Nachrichten vom ToolButton und vom Editfeld
//	werden abgefangen. Das Control ist immer in einem definieretn Zustand, wenn 
//	kein Zustand von auen gesetzt wurde, dann heute gesetzt 

KalenderWidget::KalenderWidget( QWidget* parent,  const char* name )
		:	KalenderBase( parent, name)
{ 
}

/*  
 *  Destroys the object and frees any allocated resources
 */

KalenderWidget::~KalenderWidget()
{
    // no need to delete child widgets, Qt does it all for us
	// delete m_pDatumValidator;
}


void Kalender::InitButton()
{
	m_buttonListe[0] = NULL;	// wird nicht bentigt
	m_buttonListe[1] = m_pKalenderWidget->B1Mo;
	m_buttonListe[2] = m_pKalenderWidget->B2;
	m_buttonListe[3] = m_pKalenderWidget->B3;
	m_buttonListe[4] = m_pKalenderWidget->B4;
	m_buttonListe[5] = m_pKalenderWidget->B5;
	m_buttonListe[6] = m_pKalenderWidget->B6;
	m_buttonListe[7] = m_pKalenderWidget->B7;

	m_buttonListe[8] = m_pKalenderWidget->B8Mo;
	m_buttonListe[9] = m_pKalenderWidget->B9;
	m_buttonListe[10] = m_pKalenderWidget->B10;
	m_buttonListe[11] = m_pKalenderWidget->B11;
	m_buttonListe[12] = m_pKalenderWidget->B12;
	m_buttonListe[13] = m_pKalenderWidget->B13;
	m_buttonListe[14] = m_pKalenderWidget->B14;

	m_buttonListe[15] = m_pKalenderWidget->B15Mo;
	m_buttonListe[16] = m_pKalenderWidget->B16;
	m_buttonListe[17] = m_pKalenderWidget->B17;
	m_buttonListe[18] = m_pKalenderWidget->B18;
	m_buttonListe[19] = m_pKalenderWidget->B19;
	m_buttonListe[20] = m_pKalenderWidget->B20;
	m_buttonListe[21] = m_pKalenderWidget->B21;

	m_buttonListe[22] = m_pKalenderWidget->B22Mo;
	m_buttonListe[23] = m_pKalenderWidget->B23;
	m_buttonListe[24] = m_pKalenderWidget->B24;
	m_buttonListe[25] = m_pKalenderWidget->B25;
	m_buttonListe[26] = m_pKalenderWidget->B26;
	m_buttonListe[27] = m_pKalenderWidget->B27;
	m_buttonListe[28] = m_pKalenderWidget->B28;

	m_buttonListe[29] = m_pKalenderWidget->B29Mo;
	m_buttonListe[30] = m_pKalenderWidget->B30;
	m_buttonListe[31] = m_pKalenderWidget->B31;
	m_buttonListe[32] = m_pKalenderWidget->B32;
	m_buttonListe[33] = m_pKalenderWidget->B33;
	m_buttonListe[34] = m_pKalenderWidget->B34;
	m_buttonListe[35] = m_pKalenderWidget->B35;

	m_buttonListe[36] = m_pKalenderWidget->B36Mo;
	m_buttonListe[37] = m_pKalenderWidget->B37;

    for (int i = 1; i < 38; i++)
    {
        m_buttonListe[i]->setMinimumSize(22,22);
        m_buttonListe[i]->setPaletteBackgroundColor(rahmen);
        if (    (i > 1) && ((i % 7) == 0)) {
            m_buttonListe[i-1]->setPaletteBackgroundColor(weekend);
            m_buttonListe[i]->setPaletteBackgroundColor(weekend);
        }
    }
    m_pKalenderWidget->setPaletteBackgroundColor(background);
    m_pKalenderWidget->KalenderRahmen->setPaletteBackgroundColor(rahmen);
    m_pKalenderWidget->JahrMinus->setPaletteBackgroundColor(background);
    m_pKalenderWidget->JahrPlus->setPaletteBackgroundColor(background);
    m_pKalenderWidget->MonatMinus->setPaletteBackgroundColor(background);
    m_pKalenderWidget->MonatPlus->setPaletteBackgroundColor(background);
    m_pKalenderWidget->heute->setPaletteBackgroundColor(background);
    Global::DoEvents();
    m_pKalenderWidget->adjustSize();
    Global::DoEvents();
}


void Kalender::SetAnzeige(QDate anzeigeDatum)
{
	// Die Anzeige wird auf das Datum gesetzt
	
	QString text;

	// auf den ersten Tag im Monat setzen

	m_anzeigeDatum.setYMD(	anzeigeDatum.year(),
							anzeigeDatum.month(),
							1);

	// den ersten Tag der Woche bestimmen

	m_ersterTag	 = m_anzeigeDatum.dayOfWeek();		// 1 = Montag, 2 = Dienstag usw.
	m_letzterTag = m_anzeigeDatum.daysInMonth();	// Tage in diesem Monat
	
	int i, tag = 1, 
		dieserTag = 0,
		aktuellerTag;

	bool dieserMonat = false,
		 aktuellerMonat = false;
	
	// wenn heute im Bereich der Anzeige (Monat) liegt

	if ( (m_heute.month() == m_anzeigeDatum.month()) &&
		 (m_heute.year() == m_anzeigeDatum.year()) )
	{
		 dieserMonat = true;
		 dieserTag = m_heute.day();
	}

	// wenn aktuelles Datum im Bereich der Anzeige (Monat) liegt

	if ( (m_aktuellesDatum.month() == m_anzeigeDatum.month()) &&
		 (m_aktuellesDatum.year() == m_anzeigeDatum.year()) )
	{
		 aktuellerMonat = true;
		 aktuellerTag = m_aktuellesDatum.day();
	}

	// die Wochentage / Buttons bis zum ersten (Wochen)Tag im Monat sind leer

	for (i= 1; i< m_ersterTag;i++)
	{
		m_buttonListe[i]->setEnabled(FALSE);
		m_buttonListe[i]->setText("");
	}

	// Zeichenstile festlegen 

	QFont fett(m_pKalenderWidget->B1Mo->font());
	fett.setBold(true);
	fett.setUnderline(true);
	QFont nichtFett(m_pKalenderWidget->B1Mo->font());
	nichtFett.setBold(false);
	nichtFett.setUnderline(false);


	// die Wochentage ab dem ersten Wochentag (1. des Monats) werden gezhlt


	for (i=m_ersterTag; i< (m_ersterTag + m_letzterTag); i++)
	{
		m_buttonListe[i]->setEnabled(TRUE);
		m_buttonListe[i]->setText(QString::number(tag));
		
		// den heutigen Tag hervorheben

		if (dieserMonat && (dieserTag == tag))
		{
			m_buttonListe[i]->setFont(fett);
		}
		else
		{	
			m_buttonListe[i]->setFont(nichtFett);
		}

		// den ausgewhlten Tag hervorheben

		if (aktuellerMonat && (aktuellerTag == tag))
		{
			m_buttonListe[i]->setDown(true);
		}
		else
		{	
			m_buttonListe[i]->setDown(false);
		}

		tag++;
	}

	// die Wochentag/Buttons nach dem letzten Tag im Monat sind leer 

	for ( i = m_ersterTag + m_letzterTag; i<= 37;i++)
	{
		m_buttonListe[i]->setEnabled(FALSE);
		m_buttonListe[i]->setText("");
	}

	// nun zur Anzeige des Monats

    m_pKalenderWidget->MonatJahr->setText(  QString::number(m_anzeigeDatum.month()).rightJustify(2,'0')
						                    + tr(" - ") 
						                    + QString::number(m_anzeigeDatum.year()));
}

////////////////////////////////////////////////////
//
//	Nachrichten vom Control
//


void Kalender::HeuteClick()
{
	// Es wurde auf heute geklickt
	// Die Anzeige (nicht das aktuelle Datum) wird auf den 
	// Monat gestellt, der heute ist. 

	m_heute = m_heute.currentDate();	// es knnte ja sein, 
										// dass der Nutzer um 23h 59m 59s ...
	SetAnzeige(m_heute);
}

void Kalender::JahrPlusClick()
{
	// Anzeige um 1 Jahr voraus setzen

	m_anzeigeDatum.setYMD(	m_anzeigeDatum.year() + 1,
							m_anzeigeDatum.month(),
							1);
	SetAnzeige(m_anzeigeDatum);
}

void Kalender::JahrMinusClick()
{
	// Anzeige um 1 Jahr zurcksetzen
	
	m_anzeigeDatum.setYMD(	m_anzeigeDatum.year() - 1,
							m_anzeigeDatum.month(),
							1);
	SetAnzeige(m_anzeigeDatum);
}

void Kalender::MonatPlusClick()
{
	// Monat und Jahr bestimmen

	int monat = m_anzeigeDatum.month();
	int jahr = m_anzeigeDatum.year();

	// prfen, der letzte Monat im Jahr

	if (monat >= 12)
	{
		jahr++;
		monat = 1;
	}
	else
	{
		monat++;
	}
	
	// Anzeige um 1 Monat voraus setzen

	m_anzeigeDatum.setYMD(jahr,monat,1);
	SetAnzeige(m_anzeigeDatum);
}

void Kalender::MonatMinusClick()
{
	// Monat und Jahr bestimmen 

	int monat = m_anzeigeDatum.month();
	int jahr = m_anzeigeDatum.year();

	// prfen, ob der erste Monat im Jahr

	if (monat <= 1)
	{
		jahr--;
		monat = 12;
	}
	else
	{
		monat--;
	}

	// Anzeige um 1 Monat zurck setzen

	m_anzeigeDatum.setYMD(jahr,monat,1);
	SetAnzeige(m_anzeigeDatum);
}

void Kalender::TagClick()
{
	// jemand hat auf ein Datum / Wochentag geclickt
	// von welchem Button stammt die Botschat

	const QObject *pSender = this->sender();

	// die Nummer des Buttons finden

	int i = 1, buttonNummer=1;

	for (i = 1;i <= 37;i++)
	{
		if (m_buttonListe[i] == pSender)
		{
			buttonNummer = i;			// es ist der i.te Button
		}								// die Buttons beginngen mit 1
	}

	// jetzt den Tag ausrechnen
	// wenn Wochentag wenn m_ersterTag = 1 und erster Button, dann 1

	int auswahlTag = buttonNummer - m_ersterTag + 1;

	m_aktuellesDatum.setYMD(	m_anzeigeDatum.year(),
								m_anzeigeDatum.month(),
								auswahlTag);
	m_auswahl = true;
	m_delete = false;

	QString text;

	if (	(m_pEditFeld != NULL) &&
			GetDatum(text) )
	{
		m_pEditFeld->setText(text) ;
		emit dateChanged(m_aktuellesDatum);
	}

	hide();
	// close(false);		// nur schlieen, da das Objekt
							// noch bentigt wird
}

////////////////////////////////////////////////////
//
//	Schnittstellen
//


bool Kalender::GetDatum(QString &datum)
{
	// es wird immer das aktuelle Datum zurckgegeben
	// true jedoch nur, wenn eine Auswahl stattgefunden 
	// hat. 

	if (m_delete == true)
	{
		datum = "";
		return m_auswahl;
	}


	datum = "";

	QString text;
	
	// Integer in Text umwandeln

	int tag		= m_aktuellesDatum.day();
	int monat	= m_aktuellesDatum.month();
	int jahr	= m_aktuellesDatum.year();

	if (tag <10)		// noch eine fhrende Null 
		datum +=tr("0");
	
	datum += QString::number(tag,10);
	datum += tr(".");
	
	if (monat < 10)		// noch eine fhrende Null
		datum+= tr("0");

	datum += QString::number(monat,10);
	datum += tr(".");
	datum += QString::number(jahr,10);

	// Flag zeigt an, ob die Auswahl vom Nutzer 
	// vernderung wurde

	return m_auswahl;
}


bool Kalender::GetDatum(QDate &datum)
{
	// es wird immer das aktuelle Datum zurckgegeben
	// true jedoch nur, wenn eine Auswahl stattgefunden 
	// hat. 
	
	datum = m_aktuellesDatum;
		
	// Flag zeigt an, ob die Auswahl vom Nutzer 
	// vernderung wurde

	return m_auswahl;
}

#ifdef COMPILE_ADVOLUX

bool Kalender::GetPtDate(PtDate &datum)
{
	// es wird immer das aktuelle Datum zurckgegeben
	// true jedoch nur, wenn eine Auswahl stattgefunden 
	// hat. 
	
	QMyDate myDate(m_aktuellesDatum);
	datum = myDate.GetPtDate();
		
	// Flag zeigt an, ob die Auswahl vom Nutzer 
	// vernderung wurde

	return m_auswahl;
}

PtDate Kalender::GetPtDate()
{
	// es wird immer ein Datum zurckgegeben 

	QMyDate myDate(m_aktuellesDatum);
	return myDate.GetPtDate();
}

#endif // COMPILE_ADVOLUX

QDate Kalender::GetDatum()
{
	// gibt immer ein gltiges Datum zurck
	// auch wenn der Anwender nichts ausgewhlt hat

	if (m_delete == true)
	{
		return QDate(KEIN_JAHR,1,1);
	}
	else
	{
		return m_aktuellesDatum;
	}
}


void Kalender::SetDatum(QDate datum)
{
	if (datum == QDate(KEIN_JAHR,1,1))
	{
		DeleteDatum();
		return; 
	}

	// keine Auwahl, sondern vom Programm gesetzt

	m_auswahl = false;
	m_delete = false;
	m_aktuellesDatum = datum;

	// die Anzeige wird auf das Datum gesetzt. 

	SetAnzeige(m_aktuellesDatum);
	QString datumText;
	GetDatum(datumText);

	// das Editfeld wird auch gesetzt

	if (m_pEditFeld != NULL)
	{
		m_pEditFeld->setText(datumText);
		
		if (m_nurMausklicksAlsNachricht == false)
		{
			emit dateChanged(m_aktuellesDatum);
		}
	}
}

void Kalender::DeleteDatum()
{
	// Das AnzeigeDatum wird auf den 1.1.7000 gesetzt
	// Es wird jedoch ein gesonderten m_deleteFlag gesetzt

	m_delete = true;
	m_auswahl = false;

	m_aktuellesDatum = QDate(KEIN_JAHR,1,1);
    SetAnzeige(QDate::currentDate());  // damit nicht im Jahr 4000 gestartet wird

	// das Editfeld wird auch gesetzt

	if (m_pEditFeld != NULL)
	{
		m_pEditFeld->setText("");
		
		if (m_nurMausklicksAlsNachricht == false)
		{
			emit dateChanged(QDate(KEIN_JAHR,1,1));
		}
	}
}


void Kalender::SetNurMausklicksAlsNachricht(bool nurMausklicks)
{
	// Diese Variable entscheidet, ob nur die Vernderungen durch 
	// den Benutzer (mausklick) oder auch Vernderungen durch das 
	// Programm (SetDatum) zu einer Nachricht fhren sollen
	m_nurMausklicksAlsNachricht = nurMausklicks;
}


bool Kalender::ConnectToControl(QButton *pButton, QLineEdit *pLineEdit)
{
	// verbindet das Objekt mit dem Button und dem Editfeld

	if (pButton == NULL)
	{
		return false;
	}

	// merken, wo der Button sitzt auf dessen Click
	// hin das Control startet

	m_pControlButton = pButton;

	QPoint globalPosition( m_pControlButton->x(),m_pControlButton->y() );
	globalPosition = m_pParent->mapToGlobal(globalPosition);
	move(globalPosition.x(),globalPosition.y());	// Verschieben

	// Das Clicksignal des Buttons auf das eigene Objekt legen

	connect( pButton, SIGNAL( clicked() ), this, SLOT( DatumClick() ) );

	// ein schnes Bild fr das Control

	m_pControlButton->setPixmap(QPixmap( ( const char** ) KalenderBild));
	
	// ggf. das Editfeld verbinden

	m_pEditFeld = pLineEdit;

	// wenn != NULL die Nachricht von nderung verbinden

	if (m_pEditFeld != NULL)
	{
		// m_pEditFeld->setReadOnly(true);
		SetDatum(m_aktuellesDatum);
	}

    DateValidator *m_pDateValidator = new DateValidator(this,"Date");

    m_pDateValidator->SetActualDate(m_aktuellesDatum);
    m_pDateValidator->SetKeinJahrEnabled(true);
    m_pDateValidator->SetLineEdit(m_pEditFeld);

    connect(m_pDateValidator, SIGNAL (dateChanged ( const QDate & ) ),
                        this, SLOT(DatumChange(const QDate & ) ) );   

	// Jetzt noch die Toolhilfe setzen

	QToolTip::add(pButton, tr("<p>Klicken Sie hier, wenn Sie das Datum ber einen kleinen Kalender eingeben wollen</p>") );
		
	return true;

}


////////////////////////////////////////////////////
//
//	Nachrichten von den Controls
//


void Kalender::DatumClick()
{
	// Diese Funktion wird aufgerufen, wenn jemand auf
	// den Button m_pControlButton drckt. Wenn das Datum
	// deleted ist, wird das heutige Datum voreingestellt
	// ansonsten das aktuelle Datum

	if (m_delete == true)
	{
		QDate heute = QDate::currentDate();
		SetAnzeige(heute);
	}
	else
	{
		SetAnzeige(m_aktuellesDatum);
	}
	
	// die jetzige Position des Buttons

	QPoint pos = m_pControlButton->mapToGlobal(m_pControlButton->pos() );
	pos -= m_pControlButton->pos();

	// an die Gre des Fenster anpassen

    int width = QApplication::desktop()->width();
	int height = QApplication::desktop()->height();

	if (pos.x() + this->width() > width)
	{
		pos.setX(width - this->width());
	}

	if (pos.y() + this->height() > height)
	{
		pos.setY(height - this->height());
	}

	move(pos);
    this->setGeometry(pos.x(),pos.y(),m_pKalenderWidget->width()+5,m_pKalenderWidget->height()+5);
    
    // und starten

	this->show();
}



void Kalender::DatumChange(const QDate &datum)
{
    // wird nur aufgerufen, wenn fixup durchgefhrt wurde
    // Die Verantwortung liegt beim Kalenderobjekt. Wenn Das Datum
    // aus irgendwelchen Grnden inakzeptabel ist, wird
    // unter Ausschluss von validate zurckgeschreiben

    if (    (datum.isValid() == false)  ||
            (   (m_loeschbar == false)  && (datum == QDate(KEIN_JAHR,1,1)) ) )
    {
        QString aktuellesDatum;
        m_pDateValidator->SetValidate(false);
        GetDatum(aktuellesDatum);
        m_pEditFeld->setText(aktuellesDatum);
        m_pDateValidator->SetValidate(false);
    }

    // Das Datum ist gltig. Jedoch nur dann ttig werden
    // Wenn sich das Datum gender hat

    else if (datum != m_aktuellesDatum)
    {
        if (datum == QDate(KEIN_JAHR,1,1))
        {
		    m_delete = true;
            SetAnzeige(QDate::currentDate());  // damit nicht im Jahr 4000 gestartet wird
        }
        else
        {
            m_delete = false;
            SetAnzeige(datum);
        }

	    // Auwahl ist durch Edit erfolgt 

	    m_auswahl = true;
        m_aktuellesDatum = datum;
	    
	    // die Anzeige wird auf das Datum gesetzt. 

        emit dateChanged(m_aktuellesDatum);
    }
}

void Kalender::SetLoeschbar(bool loeschbar)
{
    m_loeschbar = loeschbar; 
}



void Kalender::test()
{
   //  QMessageBox::information(NULL,"!","hallo");
}


bool Kalender::isAuswahl()
{
	return m_auswahl;
}

Kalender::Kalender(QWidget *pParent)
    :  QFrame(pParent,"Kalender", WType_Popup)
{
	m_nurMausklicksAlsNachricht = true;
    setFrameStyle( WinPanel | Raised );
    setFrameShape(WinPanel);
    setMargin(1);

    m_pKalenderWidget = NULL; 
    m_pDateValidator = NULL; 
    m_pKalenderWidget = new KalenderWidget(this,"KalenderWidget");
    m_pKalenderWidget->move(3,3);

    ConnectButtons();
		
	m_pParent = pParent;			    // darf nicht Null sein
	m_auswahl = false;					// noch keine Auswahl durch Benutzer

	m_heute = m_heute.currentDate();	// heutiges Datum einstellen
	m_anzeigeDatum = m_heute;
	m_aktuellesDatum = m_heute;
	m_ersterTag = 1;					// wird in SetAnzeige gesetzt
	m_letzterTag = 1;					// wird in SetAnzeige gesetzt
	m_pControlButton = NULL;
	m_pEditFeld = NULL;
	m_delete = false;
    m_loeschbar = false;

    InitButton();						// die Auswahlknpfe in ein Array
	SetDatum(m_heute);					// erst mal auf heute setzten
}

void Kalender::ConnectButtons()
{
    ASSERT(m_pKalenderWidget != NULL);

    // signals and slots connections
    connect( m_pKalenderWidget->JahrMinus, SIGNAL( clicked() ), this, SLOT( JahrMinusClick() ) );
    connect( m_pKalenderWidget->MonatMinus, SIGNAL( clicked() ), this, SLOT( MonatMinusClick() ) );
    connect( m_pKalenderWidget->JahrPlus, SIGNAL( clicked() ), this, SLOT( JahrPlusClick() ) );
    connect( m_pKalenderWidget->MonatPlus, SIGNAL( clicked() ), this, SLOT( MonatPlusClick() ) );
    connect( m_pKalenderWidget->heute, SIGNAL( clicked() ), this, SLOT( HeuteClick() ) );
    connect( m_pKalenderWidget->B1Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B2, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B3, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B4, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B5, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B6, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B7, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B8Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B9, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B10, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B11, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B12, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B13, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B14, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B15Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B16, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B17, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B18, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B19, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B20, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B21, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B22Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B23, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B24, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B25, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B26, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B27, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B28, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B29Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B30, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B31, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B32, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B33, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B35, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B36Mo, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B37, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
    connect( m_pKalenderWidget->B34, SIGNAL( clicked() ), this, SLOT( TagClick() ) );
}

Kalender ::~Kalender()
{
    delete m_pKalenderWidget; 
}

bool Kalender::eventFilter(QObject *pObject,QEvent *pEvent)
{
    // ... mal sehen
    return false;
}