#ifndef KALENDER_H
#define KALENDER_H

#include "kalender.h"

#include <qdatetime.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qpopupmenu.h>
#include <qbutton.h>

#ifdef COMPILE_ADVOLUX
#include <poet.hxx>
#endif COMPILE_ADVOLUX

class QToolButton;
class DateValidator;

class KalenderWidget : public KalenderBase
{ 
    friend class Kalender;

    protected: 
        KalenderWidget( QWidget* parent,const char* name);
        ~KalenderWidget();
};

class Kalender : public QFrame
{
    Q_OBJECT

    // Konstruktor
    public: 
        Kalender( QWidget* parent);
        ~Kalender();

    // Slots:
    protected slots:
	    virtual void DatumClick();
	    void         DatumChange(const QDate& date);
	    virtual void test();

    // Interne Methoden
    protected:
	    void  SetAnzeige(QDate anzeigeDatum);
        void  InitButton();
        void  ConnectButtons();
        virtual bool eventFilter(QObject *pObject,QEvent *pEvent);

    // Signals
    signals:
        void  dateChanged(const QDate&);

    // Schnittstellen
    public:
	    bool  isAuswahl();
	    void  SetDatum(QDate datum);
        void  SetLoeschbar(bool loeschbar);
	    void  DeleteDatum();
	    void  SetNurMausklicksAlsNachricht(bool nurMausklicks);
	    bool  ConnectToControl(QButton *pButton, QLineEdit * pLineEdit = NULL);
	    bool  GetDatum(QDate &datum);
	    bool  GetDatum(QString& datum);        
	    QDate GetDatum();

#ifdef  COMPILE_ADVOLUX
	    bool   GetPtDate(PtDate &datum);
	    PtDate GetPtDate();
#endif  COMPILE_ADVOLUX

    // Member
    protected:	
        QToolButton     *m_buttonListe[37];
	    QWidget		    *m_pParent;
	    QButton		    *m_pControlButton;
	    QLineEdit	    *m_pEditFeld;
        KalenderWidget  *m_pKalenderWidget;
        DateValidator   *m_pDateValidator;

	    bool	m_auswahl;
	    bool	m_nurMausklicksAlsNachricht;
	    bool	m_delete;
        bool    m_loeschbar;
	    QDate	m_anzeigeDatum;
	    QDate	m_heute;
	    QDate	m_aktuellesDatum;
	    int		m_letzterTag;
	    int		m_ersterTag;

    // Slots
    protected slots : 

	    void TagClick();
	    void MonatMinusClick();
	    void MonatPlusClick();
	    void JahrMinusClick();
	    void JahrPlusClick();
	    void HeuteClick();

    protected: 
};


#endif // KALENDER_H
